--[[
    Copyright (C) 2011 Omer Bahri Gordebak
    Using some of the code provided by:
    Copyright (c) 2010 Enrique García Cota

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Omer Bahri Gordebak <gordebak@gmail.com>
]]

level = 1
lives = 3
isSound = true
isFullscreen = false
isSplash = true
splashx = 0
musiconx = 380
musicoffx = -40
fullscreenonx = -40
fullscreenoffx = 380
difficulty = 50
difficultyonx = 380
difficultyony = 325
finishx = -650
isFinish = false
linex = 410
liney = 250
number = {}
numberx = {}
  for i = 1, 9 do
	numberx[i] = -36
  end

local tileW, tileH, tileset, quads, tileTable

function love.load()
  love.graphics.setMode( 640, 480, isFullscreen )
  love.graphics.setCaption( "One Way To Go" )
  love.mouse.setVisible( false )
  splash = love.graphics.newImage("images/splash.png")
  finish = love.graphics.newImage("images/finish.png")
  fullscreenon = love.graphics.newImage("images/on.png")
  fullscreenoff = love.graphics.newImage("images/off.png")
  musicon = love.graphics.newImage("images/on.png")
  musicoff = love.graphics.newImage("images/off.png")
  difficultyon = love.graphics.newImage("images/on.png")
  line = love.graphics.newImage("images/line.png")
  image = love.graphics.newImage("images/player.png")
  deadimage = love.graphics.newImage("images/playerdead.png")
  oops = love.graphics.newImage("images/oops.png")
  gameover = love.graphics.newImage("images/gameover.png")
  music = love.audio.newSource("other/dst-breakout.ogg")
  music:setLooping(true)
  for i = 1, 9 do
	number[i] = love.graphics.newImage("images/numbers/"..i..".png")
  end
  love.audio.play(music)
end

function love.keypressed(key)
   if key == "escape" and isSplash == true then
      love.event.push("q")
   elseif key == "escape" and isSplash == false then
      isSplash = true
      splashx = 0
      linex = 410
      liney = 250
      if isSound then
	musiconx = 380
	musicoffx = -40
      elseif isSound == false then
	musicoffx = 380
	musiconx = -40
      end
      if isFullscreen then
	fullscreenonx = 380
	fullscreenoffx = -40
      elseif isFullscreen == false then
	fullscreenoffx = 380
	fullscreenonx = -40
      end
      if difficulty ==  50 then
	difficultyony = 325
      elseif difficulty == 75 then
	difficultyony = 363
      elseif difficulty == 100 then
	difficultyony = 400
      end
	difficultyonx = 380
   end
   if key == "escape" and isFinish == true then
      love.event.push("q")
   end
    if key == " " and isGameOver then
	love.graphics.clear()
	level = 1
	loadMap("maps/level"..level..".lua")
	isGameOver = false
	isDie = false
	lives = 3
	gameoverx= - 650
    elseif key == " " and isGameOver == false and isDie == true then
	love.graphics.clear()
	loadMap("maps/level"..level..".lua")
	isGameOver = false
	isDie = false
	oopsx = -650
    elseif key == " " and isSplash == true then
	love.graphics.clear()
	isSplash = false
	splashx = -650
	fullscreenonx = -40
	fullscreenoffx = -40
	musiconx = -40
	musicoffx = -40
	linex = -300
	difficultyonx = -40
	loadMap("maps/level"..level..".lua")
	end
    if key == "down" and isSplash == true then
	liney = liney + 38
	if liney > 402 then
	liney = 250
	end
    end
    if key == "up" and isSplash == true then
	liney = liney - 38
	if liney < 250 then
	liney = 402
	end
    end
    if key == "return" and isSplash == true then
	if liney == 250 and isSound then
	  musiconx = -40
	  musicoffx = 380
	  isSound = false
	  music:stop()
        elseif liney == 250 and isSound == false then
	  musicoffx = -40
	  musiconx = 380
	  isSound = true
	  love.audio.play(music)
	end
        if liney == 288 and isFullscreen then
	  fullscreenonx = -40
	  fullscreenoffx = 380
	  isFullscreen = false
          love.graphics.setMode( 640, 480, false )
	elseif liney == 288 and isFullscreen == false then
	  fullscreenonx = 380
	  fullscreenoffx = -40
	  isFullscreen = true
          love.graphics.setMode( 640, 480, true )
	elseif liney == 326 then
	  difficulty = 50
	  difficultyony = 325
	elseif liney == 364 then
	  difficulty = 75
	  difficultyony = 363
	elseif liney == 402 then
	  difficulty = 100
	  difficultyony = 400
	end
    end
end

function love.update(dt)
    dv = difficulty * dt
if isSplash == false then
    if love.keyboard.isDown("left") then
	velx = -dv
	vely = 0
    end
    if love.keyboard.isDown("right") then
	velx = dv
	vely = 0
    end
    if love.keyboard.isDown("up") then
	vely = -dv
	velx = 0
    end
    if love.keyboard.isDown("down") then
	vely = dv
	velx = 0
    end
	for _, r in ipairs(bgcorners) do
	if CheckCollision(ballx, bally, 24, 24, r[1], r[2], 24, 24) then
	velx = 0
	vely = 0
	deadx, deady = ballx, bally
	ballx, bally= -100,-100
	lives = lives - 1
		if lives == 0 then 
   		isGameOver = true
    		isDie = true
		theend()
		end
		if lives > 0 then 
		isGameOver = false
		isDie = true
		die()
		end
	end
	end

	for _, row in ipairs(tilecorners) do
	if CheckCollision(ballx, bally, 16, 16, row[1], row[2], 16, 16) and tileTable[row[1]/32+1][row[2]/32+1] == " " then
	tileTable[row[1]/32+1][row[2]/32+1] = "D"
	drawMap()
	elseif CheckCollision(ballx, bally, 24, 24, row[1], row[2], 24, 24) and tileTable[row[1]/32+1][row[2]/32+1] == "%" then
	tileTable[row[1]/32+1][row[2]/32+1] = "½"
	drawMap()
	elseif CheckCollision(ballx, bally, 24, 24, row[1], row[2], 24, 24) == false and tileTable[row[1]/32+1][row[2]/32+1] == "½" then
	tileTable[row[1]/32+1][row[2]/32+1] = " "
	drawMap()
	elseif CheckCollision(ballx, bally, 24, 24, row[1], row[2], 24, 24) == false and tileTable[row[1]/32+1][row[2]/32+1] == "D" then
	tileTable[row[1]/32+1][row[2]/32+1] = "#"
	drawMap()
	elseif CheckCollision(ballx, bally, 24, 24, row[1], row[2], 24, 24) and tileTable[row[1]/32+1][row[2]/32+1] == "#" then
		velx = 0
		vely = 0
		deadx, deady = ballx, bally
		ballx, bally= -100,-100
		lives = lives - 1
		if lives == 0 then 
   		isGameOver = true
    		isDie = true
		theend()
		end
		if lives > 0 then 
		isGameOver = false
		isDie = true
		die()
		end
	end
	end

	if trcx[1] ~= nil then
	if CheckCollision(ballx, bally, 16, 16, trcx[2], trcy[2], 16, 16) then
	velx = 0
	vely = 0
        ballx, bally = trcx[1], trcy[1]	
	end
	end

	if CheckCollision(ballx, bally, 12, 12, exitx, exity, 12, 12) then
  	for columnIndex,column in ipairs(tileTable) do
   	 for rowIndex,char in ipairs(column) do
    	  if char == ' ' then left = left +1 end
    	end
 	end
	  if left == 0 then
           level = level + 1
		if level == 10 then lives = lives + 1 end
		if level < 21 then 
	        loadMap('maps/level' .. level .. '.lua')	        
		elseif level == 21 then
		finished() 
		end
	  elseif left > 0 then
	deadx, deady = ballx, bally
	ballx, bally= -100,-100
		lives = lives - 1
		if lives == 0 then 
   		isGameOver = true
    		isDie = true
		theend()
		end
		if lives > 0 then 
		isGameOver = false
		isDie = true
		die()
		end
	die()
	end
	end        
	ballx = ballx + velx
        bally = bally + vely
	for i = 1, 9 do
		numberx[i] = -36
	end
	numberx[lives] = 580
end
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function love.draw()
  if isSplash == false and isFinish == false then
  drawMap()
  love.graphics.draw(image, ballx, bally)
  love.graphics.draw(deadimage, deadx, deady)
  love.graphics.draw(oops, oopsx, 0)
  love.graphics.draw(gameover, gameoverx, 0)
  for i = 1, 9 do
  love.graphics.draw(number[i], numberx[i], 20)
  end
  end
  love.graphics.draw(splash, splashx, 0)
  love.graphics.draw(fullscreenon, fullscreenonx, 285)
  love.graphics.draw(fullscreenoff, fullscreenoffx, 285)
  love.graphics.draw(musicon, musiconx, 245)
  love.graphics.draw(musicoff, musicoffx, 245)
  love.graphics.draw(difficultyon, difficultyonx, difficultyony)
  love.graphics.draw(line, linex, liney)
  love.graphics.draw(finish, finishx, 0)
end

function loadMap(path)
  love.filesystem.load(path)() -- attention! extra parenthesis
end

function newMap(tileWidth, tileHeight, tilesetPath, tileString, quadInfo, ballx, bally)

deadx, deady = -40, -40
oopsx = -650
gameoverx = -650
velx, vely = 0, 0
bgcorners = {}
tilecorners = {}
trcx = {}
trcy = {}
exitx,exity = 0,0
cb = 0
ct = 0
cg = 0
ctr = 0
cstr = 0
left = 0  
isGameOver = false
isDie = false

  tileW = tileWidth
  tileH = tileHeight
  tileset = love.graphics.newImage(tilesetPath)
  
  local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
  
  quads = {}
  
  for _,info in ipairs(quadInfo) do
    -- info[1] = the character, info[2] = x, info[3] = y
    quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW,  tileH, tilesetW, tilesetH)
  end
  
  tileTable = {}
  
  local width = #(tileString:match("[^\n]+"))

  for x = 1,width,1 do tileTable[x] = {} end

  local rowIndex,columnIndex = 1,1
  for row in tileString:gmatch("[^\n]+") do
    assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    columnIndex = 1
    for character in row:gmatch(".") do
      tileTable[columnIndex][rowIndex] = character
	if character == "#" then
	  cb = cb + 1
	  bgcorners[cb] = { (columnIndex - 1)*tileW, (rowIndex - 1)*tileH }
	end
	if character == " "  or character == "%" then
	  ct = ct + 1
	  tilecorners[ct] = { (columnIndex - 1)*tileW, (rowIndex - 1)*tileH, rowIndex, columnIndex }
	end
	if character == "X" then
	  exitx = (columnIndex - 1)*tileW
	  exity = (rowIndex - 1)*tileH
	end
	if character == "G" then
	  ctr = ctr + 1
	  trcx[ctr] = (columnIndex - 1)*tileW
          trcy[ctr] = (rowIndex - 1) * tileH 
	end
      columnIndex = columnIndex + 1
    end
    rowIndex=rowIndex+1
  end

end

function drawMap()
  for columnIndex,column in ipairs(tileTable) do
    for rowIndex,char in ipairs(column) do
      local x,y = (columnIndex-1)*tileW, (rowIndex-1)*tileH
      love.graphics.drawq(tileset, quads[ char ] , x, y)
    end
  end
end

function die()
	oopsx = 0
	gameoverx = -650
end

function theend()
	gameoverx = 0	
	oopsx = -650
end

function finished()
	ballx = -650
	deadx = -650
	oopsx = -650
	gameoverx = -650
	  for i = 1, 9 do
		numberx[i] = -650
	  end
	splashx = -650
	fullscreenonx = -650
	fullscreenoffx = -650
	musiconx = -650
	musicoffx = -650
	difficultyonx = -650
	linex = -650
	finishx = 0
	isFinish = true
end
